<template>
  <div id="material_upload_wrapper">
    <!-- 강의 자료 및 영상 업로드 -->
    <el-row>
      <el-col :span="12">
        <h3>{{ $t('LECTURE_MANAGE.UPLOAD_MATERIAL') }}</h3>
        <br />
        <el-upload
          action="#"
          multiple
          :http-request="doUpload"
          :on-remove="handleRemove"
          :on-preview="fileDownload"
          :file-list="fileList"
          ref="materialUpload"
        >
          <el-button slot="trigger" type="primary">{{ $t('MATERIAL.ADD') }}</el-button>
          <el-button size="small" type="text"> &#42; {{ $t('MATERIAL.NOTYPE') }} </el-button>
        </el-upload>
      </el-col>
    </el-row>
    <!-- 강의자료 & 키워드 목록 -->
    <div style="height: 100px;" />
    <h3>{{ $t('MATERIAL.CONNECT') }}</h3>
    <el-table
      ref="multipleTable"
      :data="fileNameKeywordList"
      style="width: 100%"
      @selection-change="handleSelectionChange">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column :label="$t('MATERIAL.NAME')" width="450px">
        <template slot-scope="scope">{{ scope.row.data.file.name }}</template>
      </el-table-column>
      <el-table-column :label="$t('MATERIAL.KEYWORDS')">
        <template slot-scope="scope">
          <el-tag v-for="(k, index) in scope.row.keywordList" :key="index" closable @close="deleteMKeyword(scope.row.data, k)">{{ k.keyword }} / {{ k.score_portion }}</el-tag>
        </template>
      </el-table-column>
    </el-table>
    <div style="height: 50px;" />

    <el-button @click="selectKeyword">{{ $t('LECTURE_MANAGE.SLCT_KEY') }}</el-button>
    <el-dialog
      :title="$t('LECTURE_MANAGE.SLCT_KEY')"
      :visible.sync="centerDialogVisible"
      width="40%">
      <div>
        <table id="table_design" :data="checkList">
          <thead>
            <tr>
              <td>{{ $t('KEYWORD.LEC_KEY') }}</td>
              <td>{{ $t('LECTURE_MANAGE.ALLOTS') }}</td>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(k, index) in input.lectureKeyword" :key="index">
              <td>
                <el-input v-model="k.keyword" v-show="k.edit"></el-input>
                <span v-show="!k.edit">{{ k.keyword }}</span>
              </td>
              <td>
                <el-input-number  v-model="k.keywordPoint"  :controls=false ></el-input-number>
              </td>
            </tr>
          </tbody>
        </table>  
        <el-button @click="onClick('ADD_KEYWORD')" style="width: 100px">{{ $t('LECTURE_MANAGE.ADD') }}</el-button><br><br>
      </div>
    </el-dialog> <br><br>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import { baseUrl } from '../../services/config';
import utils from '../../utils';
import lectureService from '../../services/lectureService';

export default {
  name: 'MaterialUpload',
  data() {
    return {
      videolink: '',
      modifiedLink: '',
      fileNameKeywordList: [],
      fileList: [],
      centerDialogVisible: false,
      checkList: [],
      keywordPoint: [],
      input: {
        lectureKeyword: [],
      },
      multipleSelection: [],
    };
  },
  // 페이지 로딩시 강의자료와 키워드들 불러오기
  async mounted() {
    const vm = this;
    let i1;
    const lcmaterial = await lectureService.getLectureMaterial({
      lectureId: vm.$route.params.lectureId,
    });
    lcmaterial.data.forEach((x) => {
      vm.fileList.push(x.file);
    });

    for (i1 = 0; i1 < lcmaterial.data.length; i1 += 1) {
      const dictMaterial = {};
      dictMaterial.data = lcmaterial.data[i1];
      const materialKeywords = await lectureService.getMaterialKeywords({ // eslint-disable-line
        id: lcmaterial.data[i1].material_id,
      });
      dictMaterial.keywordList = materialKeywords.data;
      vm.fileNameKeywordList.push(dictMaterial);
    }

    const lcs = await lectureService.getLecture({
      lectureId: vm.$route.params.lectureId,
    });
    if (lcs.data.video_link !== null) {
      vm.videolink = lcs.data.video_link;
      vm.modifiedLink = lcs.data.video_link;
    }
    const lckeywords = await lectureService.getLectureKeywords({
      lectureId: vm.$route.params.lectureId,
    });
    lckeywords.data.forEach((element) => {
      element.keywordPoint = 0;
      vm.input.lectureKeyword.push(element);
    });
  },
  computed: {
    ...mapState('keyword', [
      'keywordList',
    ]),
    modifiedKeywordList() {
      const vm = this;
      return vm.keywordList.map(x => ({ value: x.keyword }));
    },
    combinedUrl() {
      const vm = this;
      const id = getIdFromURL(vm.videolink);
      return `https://www.youtube.com/embed/${id}`;
    },
  },
  methods: {
    // 강의자료 업로드 (이 때 키워드는 당연히 비어있음)
    async doUpload(req) {
      const vm = this;
      // 서버에 저장할 것.

      const lecmaterial = await lectureService.postLectureMaterial({
        lectureId: vm.$route.params.lectureId,
        file: req.file,
      });

      // guid 받아서 uploadFiles 배열속 객체의 guid 속성으로 넣을 것
      const uploadfiles = vm.$refs.materialUpload.uploadFiles.find(
        element => element.uid === req.file.uid,
      );

      uploadfiles.file_guid = lecmaterial.data.file.file_guid;
      // 방금 넣은 강의자료 다시 받아오기
      const newMaterial = await lectureService.getLectureMaterial({
        lectureId: vm.$route.params.lectureId,
      });
      // 서버에 가장 나중에 넣은 강의자료 찾기
      let lastUploadNum = 0;
      let lastUploadTime = newMaterial.data[0].created_at;
      newMaterial.data.forEach((x, i) => {
        if (lastUploadTime < x.created_at) {
          lastUploadNum = i;
          lastUploadTime = x.created_at;
        }
      });

      // 최신 강의자료를 빈 키워드리스트와 묶어서 list에 넣기
      const dictMaterial = {};
      dictMaterial.keywordList = [];
      dictMaterial.data = newMaterial.data[lastUploadNum];
      vm.fileNameKeywordList.push(dictMaterial);
      vm.fileList.push(newMaterial.data[lastUploadNum].file);
    },
    async handleRemove(file) {
      // 삭제하는 파일의 id를 이용하여 서버에서 파일 삭제
      const indexFile = this.fileList.indexOf(file);
      const materialId = this.fileNameKeywordList[indexFile].data.material_id;
      await lectureService.deleteMaterial({
        id: materialId,
      });
      if (this.fileList.includes(file)) {
        this.fileList.splice(indexFile, 1);
        this.fileNameKeywordList.splice(indexFile, 1);
      }
      // uploadFiles 배열에서 해당 항목 삭제 (자동적으로 이뤄짐)
    },
    // 강사가 파일 다운로드할 수 있게 추가 190628
    async fileDownload(file) {
      const downFile = [];
      downFile.push(file);
      utils.downloadFiles(baseUrl, downFile);
    },
    querySearch(queryString, cb) {
      const vm = this;
      const results = queryString ?
        vm.modifiedKeywordList.filter(vm.createFilter(queryString)) : vm.modifiedKeywordList;
      // call callback function to return suggestions
      cb(results);
    },
    createFilter(queryString) { // eslint-disable-next-line
      return (link) => {
        return (link.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
      };
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    async onClick(type, arg, arg2) {
      const vm = this;
      let checkDup;
      switch (type) {
        case 'ADD_KEYWORD': {
          for (let i = 0; i < vm.multipleSelection.length; i++) {
            for (let j = 0; j < vm.multipleSelection[i].keywordList.length; j++) {
              await vm.delKey(vm.multipleSelection[i].keywordList[j].material_id, vm.multipleSelection[i].keywordList[j].keyword);
            }
          }
          vm.multipleSelection.forEach((x) => {
            x.keywordList = [];
            vm.input.lectureKeyword.forEach((y) => {
              if (y.keywordPoint != 0) {
                // 프론트 상에 추가
                const fileNum = vm.fileList.indexOf(x.data.file);
                vm.fileNameKeywordList[fileNum].keywordList.push({
                  keyword: y.keyword,
                  score_portion: y.keywordPoint,
                  score: y.keywordPoint,
                });
                // vm.fileNameKeywordList[fileNum].keywordList.push(dictKeyword);
                // 서버 상에 추가
                const materialId = this.fileNameKeywordList[fileNum].data.material_id;
                lectureService.postMaterialKeyword({
                  id: materialId,
                  keyword: y.keyword,
                  score: y.keywordPoint,
                }).then(() => {
                  console.log('!');
                });
              }
            });
          });
          vm.input.lectureKeyword.forEach((x) => {
            x.keywordPoint = 0;
          });
          vm.centerDialogVisible = false;
          break;
        }
        // 키워드 삭제
        case 'DELETE_KEYWORD': {
          let keyNum;
          const fileNum = vm.fileList.indexOf(arg.file);
          const materialId = vm.fileNameKeywordList[fileNum].data.material_id;
          vm.fileNameKeywordList[fileNum].keywordList.forEach((x, i) => {
            if (x === arg2) {
              keyNum = i;
            }
          });
          // 프론트에서 삭제
          const keywordName = vm.fileNameKeywordList[fileNum].keywordList[keyNum].keyword;
          vm.fileNameKeywordList[fileNum].keywordList.splice(keyNum, 1);
          // 서버에서 삭제
          lectureService.deleteMaterialKeyword({
            id: materialId,
            key: keywordName,
          });
          break;
        }
        case 'LINKUPLOAD': {
          vm.videolink = vm.modifiedLink;
          lectureService.putLecture({
            lecture_id: vm.$route.params.lectureId,
            video_link: vm.videolink,
          });
          break;
        }
        default : {
          break;
        }
      }
    },
    async delKey(id, keyword) {
      lectureService.deleteMaterialKeyword({
        id: id,
        keyword: keyword,
      });
    },
    selectKeyword() {
      const vm = this;
      // 키워드를 등록할 강의자료를 선택하지 않은 경우
      if (vm.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.SEL_LEC_MAT_KEY'),
          type: 'warning',
        });
      } else {
        vm.centerDialogVisible = true;
      }
    },
    async deleteMKeyword(arg, arg2) {
      const vm = this;
      let keyNum;
      const fileNum = vm.fileList.indexOf(arg.file);
      const materialId = vm.fileNameKeywordList[fileNum].data.material_id;
      vm.fileNameKeywordList[fileNum].keywordList.forEach((x, i) => {
        if (x === arg2) {
          keyNum = i;
        }
      });
      // 프론트에서 삭제
      const keywordName = vm.fileNameKeywordList[fileNum].keywordList[keyNum].keyword;
      vm.fileNameKeywordList[fileNum].keywordList.splice(keyNum, 1);
      // 서버에서 삭제
      await lectureService.deleteMaterialKeyword({
        id: materialId,
        keyword: keywordName,
      });
    },
  },
};
</script>